-- This file is for lua-functionality that is specific to the dino2 ruleset.

function tech_researched_callback(tech, player, source)
  future_start_str = "Future Tech."
  truncated_tech_str = string.sub(tech:name_translation(), 1, string.len(future_start_str))
  if truncated_tech_str == future_start_str and source == "researched" then
    edit.add_player_history(player, 10)
    notify.player(nil, "%s nation researched a Future Tech. and gained 10 culture",
                  player.nation:name_translation())
  end

  -- continue processing
  return false
end

signal.connect("tech_researched", "tech_researched_callback")


function unit_lost_callback(unit, loser, reason)
  if reason == "killed" then
    killer_owner = ""
    num_killer_owners = 0
    nation = loser.nation:name_translation()
    if nation == "Animal Kingdom" then
      notify.player(nil, "%s killed", unit.utype:name_translation())
      for tile in unit.tile:square_iterate(1) do
        if unit.tile ~= tile then
          for foe in tile:units_iterate() do
            foe_nation = foe.owner.nation:name_translation()
            if killer_owner ~= foe.owner and foe_nation ~= "Animal Kingdom" then
              num_killer_owners = num_killer_owners + 1
              killer_owner = foe.owner
            end
          end
        end
      end

      if num_killer_owners == 1 then
        gold = 10
        culture = 1
        edit.change_gold(killer_owner, gold)
        edit.add_player_history(killer_owner, 1)
        if killer_owner:is_human() then
          notify.player(killer_owner,
                    "%s killed, reward is %d culture point and %d gold.",
                     unit.utype:name_translation(), culture, gold)
        end
      end
    else -- not nation == "Animal Kingdom"
      num_animal_killers = 0
      for tile in unit.tile:square_iterate(1) do
        if unit.tile ~= tile then
          for foe in tile:units_iterate() do
            foe_nation = foe.owner.nation:name_translation()
            if foe_nation == "Animal Kingdom" then
              num_animal_killers = num_animal_killers + 1
              foe_unit = foe
            end
          end
        end
      end
      if num_animal_killers > 0 then
        notify.player(nil, "%s killed someone", foe_unit.utype:name_translation())
      end
    end
  end
  -- continue processing
  return false
end

signal.connect("unit_lost", "unit_lost_callback")


function disaster_occurred_callback(disaster, city, had_internal_effect)
  if had_internal_effect then
    notify.all("%s in %s", disaster:name_translation(), city.name)
  end
end

signal.connect("disaster_occurred", "disaster_occurred_callback")


function report_culture_callback(turn, year)
  if turn % 30 == 15 then
--  if true then
    culture_str = ""
    culture_table = {}
    for player in players_iterate() do
      if player.nation:name_translation() ~= "Animal Kingdom" and
          player.nation:name_translation() ~= "Barbarian" and
          player.nation:name_translation() ~= "Pirate" then
        culture_table[player.nation:name_translation()] = player:culture()
      end
    end
--    table.sort(culture_table)
    for n, c in pairs(culture_table) do
      st = string.format("%s nation has %d culture.\n", n, c)
      culture_str = culture_str .. st
    end
    notify.player(nil, culture_str)
  end
  return false
end

signal.connect("turn_started", "report_culture_callback")
